#pragma once

typedef unsigned char byte;
typedef unsigned word;
#define NOINIT __attribute__((section(".noinit")))
#define UNUSED __attribute__((unused))
#define elemof(x) (sizeof(x)/sizeof(*(x)))
#ifndef __cplusplus
typedef enum{false,true} bool;
#endif

void usbInit(void);		// initialize everything
void usbPoll(void);

extern byte usbCfg;
// zero when we are not configured, non-zero when enumerated
inline byte usb_configured(void) {return usbCfg;}	// is the USB port configured

bool usb_putchar(char c);	// transmit a character. On full buffer returns false
void usb_flush(void);		// immediately transmit any buffered output
int usb_getchar(void);		// returns -1 when no character is available
